define("customJavascript_a4", [
  "blocklylib" 
  ,"./blockly/generators/javascript"
  ,"./blockly/msg"
],function(BlocklyLib, generators, msg){


  //READ VOLTAGE : Loupiot
  generators['picaxe_a4_loupiot_voltage'] = function (block) {
    var voltageLoupiot = generators.variableDB_.getName(block.getFieldValue("NAME"), BlocklyLib.Variables.NAME_TYPE);
    var code = voltageLoupiot + " = picaxe.pin.analog.trigger(\"B.5\");\n";
    code += "picaxe.pause(200);\n";
    code += voltageLoupiot + " = picaxe.pin.analog.read(\"B.5\");";
    return generators.wrapOutput(block, code);
  };

  //BLUETOOTH RX:
  generators['picaxe_a4_bluetooth_rx'] = function (block) {
    var varName = generators.variableDB_.getName(block.getFieldValue('NAME'), BlocklyLib.Variables.NAME_TYPE);
    var code = varName + " = picaxe.serial.EUSART.read();";
    return generators.wrapOutput(block, code);
  };

  //BLUETOOTH TX:
  generators['picaxe_a4_bluetooth_tx'] = function (block) {
    var value = generators.valueToCode(block, 'VALUE', generators.ORDER_ATOMIC);
    if (!value) value = 0;
    var code = "picaxe.serial.EUSART.write(0," + value + ");\n";
    code += generators.getInnerStepCode(block);
    code += "picaxe.pause(100);";
    return generators.wrapOutput(block, code);
  };

//MOTOR CONTROL: portal
generators['picaxe_a4_portal'] = function (block) {
    var dirPortal = {
      "OPEN": "picaxe.pin.write([\"B.7\"],1); \npicaxe.pin.write([\"B.6\"],0)",
      "CLOSE": "picaxe.pin.write([\"B.6\"],1); \npicaxe.pin.write([\"B.7\"],0)",
      "STOP": "picaxe.pin.write([\"B.6\",\"B.7\"],0)"
    };
    var code = dirPortal[block.getFieldValue('DIRECTION')] + ";";
    return generators.wrapOutput(block, code);
};

});